const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const watchlist_items = sequelize.define(
    'watchlist_items',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

added_at: {
        type: DataTypes.DATE,
      
      

      },

alert_above_price: {
        type: DataTypes.DECIMAL,
      
      

      },

alert_below_price: {
        type: DataTypes.DECIMAL,
      
      

      },

alerts_enabled: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

note: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  watchlist_items.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity





































//end loop



    db.watchlist_items.belongsTo(db.watchlists, {
      as: 'watchlist',
      foreignKey: {
        name: 'watchlistId',
      },
      constraints: false,
    });

    db.watchlist_items.belongsTo(db.market_symbols, {
      as: 'market_symbol',
      foreignKey: {
        name: 'market_symbolId',
      },
      constraints: false,
    });




    db.watchlist_items.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.watchlist_items.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return watchlist_items;
};


